#!/usr/local/bin/perl

require "flush.pl";

sub sendgui {
    local($i);
    local($screen,$name,$value) = @_;
    for ($i=0;$i<=$#pipe_array;$i++) {
	if($screen eq $pipe_array[$i][0]) {
	    $writeID = $pipe_array[$i][2];
	    printf($writeID "%s|%s|~\n",$name,$value);
	    flush($writeID);
            if ($! eq "Broken pipe") {
                $! = 0;
		$pipe_array[$i][0] = "";
            }
 	}
    }			       
}

sub gui_exec {
    local($i);
    local($screen,$command) = @_;
    for ($i = 0;$i <= $#pipe_array;$i++) {
	if($screen eq $pipe_array[$i][0]) {
	    $writeID = $pipe_array[$i][2];
	    printf($writeID "evaluate|%s|~\n",$command);
	    flush($writeID);
            if ($! eq "Broken pipe") {
                $! = 0;
		$pipe_array[$i][0] = "";
            }
 	}
    }
}

sub gui_cleanup {
    local($i);

    for ($i = 0;$i <= $#pipe_array;$i++) {
      $writeID = $pipe_array[$i][2];
      printf($writeID "evaluate|exit|~\n");
      flush($writeID);
      if ($! eq "Broken pipe") {
        $! = 0;
        $pipe_array[$i][0] = "";
      }
    }
}


sub guival {
    local($i);
    local($screen,$var) = @_;
    for ($i=0;$i<=$#pipe_array;$i++) {
	if($screen eq $pipe_array[$i][0]) {
	    $writeID = $pipe_array[$i][2];
	    $readID = $pipe_array[$i][1];
	    printf($writeID "guigetval|%s|~\n",$var);
	    flush($writeID);
	    $val = <$readID>;
	}			
    }
    return $val;
}


sub popgui {
    local($i);
    local($screen,$exec) = @_;
    $SIG{'PIPE'} = 'IGNORE';
    if ($#pipe_array == -1) {
	$write = wh00;
	$read = $screen;
    } else {
        $write++;
	$read = $screen;
    }
    ($read,$write) = p_comm("tcl_bridge $exec",$read,$write);
    $new_index = -1;
    for ($i=0;$i<=$#pipe_array;$i++) {
	if($pipe_array[$i][0] eq "") {
	    $new_index = $i;
            last;
        }
    }
    if ($new_index == -1) {
      $new_index = $#pipe_array + 1;
    }
    $pipe_array[$new_index][0] = $screen;
    $pipe_array[$new_index][1] = $read;
    $pipe_array[$new_index][2] = $write;
#    wait;
}

sub p_comm {
    local($exec,$read,$write) = @_;

    pipe(CHILD_READ,$write);
    pipe($read,PARENT_WRITE);
    if ($pid = fork) {		
    #parent read stuff from the gui on PARENT_READ
    #       write stuff to the gui on CHILD_WRITE
	close(CHILD_READ);
	close(PARENT_WRITE);  
	select($write);$| = 1;
	select(STDOUT);
    } elsif (defined $pid) { 
    #child
	close($write);
	close(STDIN);
	close(STDOUT);
#	$read=fh0;
#	$write=fh1;
	open(STDIN,"<&CHILD_READ");
	open(STDOUT,">&PARENT_WRITE");
	close(CHILD_READ);
	close($read);  
	close(PARENT_WRITE);  
	exec $exec;
    }
    return($read,$write);
}
